package myHandler;

use strict;
use vars qw ( $AUTOLOAD );

my $hl_node="programlisting";
my $hl_attrib="lang";
my $indent="    ";
my $nindent=0;
my $marge;
my $colorize=0;
my $tocolorize;
my $lang;
my $doc;

sub new {
	my $type = shift;
	my $self = ( $#_ == 0 ) ? shift : { @_ };
	return bless $self, $type;
}

sub start_document{
	$doc .= "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	$doc .= "<!DOCTYPE article PUBLIC \"-//OASIS//DTD DocBook XML V4.4//EN\"\n";
	$doc .= "\"http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd\">\n";
}

sub end_document{
	#$doc .= "[Fin de l'analyse du document]\n";
	return $doc;
}

sub start_element{
	my $xp = shift;
	my $el = shift;
	
	$marge = ${indent}x${nindent};
	my @Attributes = keys %{$el->{Attributes}};
	my $name = $el->{Name};
	$doc .= "$marge<$name";
	foreach my $att (@Attributes){
		my $val = $el->{Attributes}->{$att};
		$doc .= " $att=\"$val\"";
		if (( $att eq $hl_attrib )&&($el->{Name} eq $hl_node )){
			$lang=$el->{Attributes}->{$att};
			$colorize=1;
		}
	}
	$doc .= ">";
	$nindent++;
}

sub end_element{
	my $xp = shift;
	my $el = shift;
	
	$nindent--;
	my $name = $el->{Name};
	if ( $el->{Name} =~ /$hl_node/ ){

		$tocolorize =~ s/&gt;/>/g;
		$tocolorize =~ s/&lt;/</g;

		$doc .= "\n\[lang=$lang\]\n<![CDATA[$tocolorize]]>\n\[\/lang\]\n";

		$colorize=0;
		$lang="";
		$tocolorize="";
	}
	$doc .= "</$name>\n";

}
sub characters{
        my $xp = shift;
	my $el = shift;

	my @keysel=keys %$el;

	if (  $colorize ne "0" ){
		$tocolorize .= $el->{Data};
		
	}
	else{
		$doc .= $el->{Data} if ( defined $el->{Data} );
	}
}
1;
